<template>
    <div class="bt-container">
        <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
            <el-breadcrumb-item v-if="className !== ''" :to="{ path: '' }">{{ className }}</el-breadcrumb-item>

            <el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
        <div style="text-align: right;">
            <a href="javascript:history.back();">
                <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
            </a>
        </div>
    </el-breadcrumb>
        <el-table
            :data="pagedTableData"
            empty-text="작성된 글이 없습니다."
        >
            <el-table-column
                type="index"
                label="번호"
                sortable
                width="130"
            >
            </el-table-column>
            <el-table-column
                prop="name"
                label="제목"
            >
            </el-table-column>
            <el-table-column
                prop="userName"
                label="작성자"
                width="180"
            >       
            </el-table-column>
            <el-table-column
                prop="date"
                label="등록일"
                width="230"
            >       
            </el-table-column>
            <el-table-column
                prop="numViews"
                label="조회수"
                sortable
                width="180"
            >       
            </el-table-column>
            <el-table-column
                fixed="right"
                width="100"
            >
                <template slot-scope="scope">
                    <el-button @click="moveTo(scope.row)">Detail</el-button>
                </template>
            </el-table-column>
        </el-table>

        <div>
        <el-form>
            
            <div style="display: inline; position:relative;">
            <el-select v-model="tempSearchType" size="small" style="display: inline-block; width: 100px; margin-top: 40px;">
                <el-option
                    v-for="(option,index) in selectOptionList"
                    :key="index"
                    :label="option"
                    :value="option"
                >
                </el-option>
            </el-select>
                <div style="display: inline-block; width: 200px; margin-top: 40px;">
                    <el-input :disabled="searchAble" placeholder="검색어를 입력하세요" width="10px" v-model="tempsearch" clearable @keydown.enter.native.prevent="searchBoards">
                        <!-- <el-button slot="append" icon="el-icon-search " @click="searchBoards"></el-button> -->
                    </el-input>
                </div>
                <el-button icon="el-icon-search" circle @click="searchBoards"></el-button>
                
            
            </div>
        
        <!-- <div class="pagination"> -->
        <el-button style="display: inline; float: right; margin-top: 40px;"><router-link class="href" :to="{ name: 'NNClassQuestionAnswerWrite', params: { classId: boards[0]? boards.classId: '' }}">글쓰기</router-link></el-button>

            <el-pagination
                v-if="searchType === '' || '모두'"
                layout="prev, pager, next"
                :total="boards.length"
                @current-change="setPage"
                style="display: inline; float: right; margin-top: 40px;"
            >
            </el-pagination>
            <el-pagination
                v-else
                layout="prev, pager, next"
                :total="pagedTableData.length"
                @current-change="setPage"
                style="display: inline; float: right; margin-top: 40px;"
            >
            </el-pagination>
        </el-form>
        </div> 
    </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';
import classService from '../../services/classService';

export default {
    // ----------------------data 부분 ------------------------//
    data() {
        return {
            boards: [],
            showAllBoard : false, 
            tempsearch: '',
            page: 1,
            pageSize: 10,
            searchBoard: '',
            tempSearchType: '',
            searchType:'',
            selectOptionList: ['모두', '제목', '작성자'],
            searchInputable: true,
        }
    },
    // ----------------------data 부분 ------------------------//

    // ----------------------computed 부분 --------------------//
    computed: {
        ...mapState('NNclass', ['studyingClassList']),
        ...mapGetters('NNclass', [
            'currentTeachingClass',
            'currentStudyingClass',
            'currentPreviewClass',
        ]),
        searchAble(){
            if(this.tempSearchType==='모두')
            return true
        },
        boardsSimple() {
          const vm = this;
          return vm.boards.slice(0, vm.boards.boardShowNumber);
        },
        pagedTableData(){
            if(this.searchType === '제목')
            {
                return this.boards.filter(data => data.name.includes(this.searchBoard)).slice(this.pageSize * this.page - this.pageSize, this.pageSize * this.page)
            }
            else if(this.searchType === '작성자')
            {
                return this.boards.filter(data => data.userName.includes(this.searchBoard)).slice(this.pageSize * this.page - this.pageSize, this.pageSize * this.page)
            }
            else if(this.searchType === '모두')
            {
                return this.boards.slice(this.pageSize * this.page - this.pageSize, this.pageSize * this.page)
            }
            else{
                return this.boards.slice(this.pageSize * this.page - this.pageSize, this.pageSize * this.page)
            }
            // :data="pagedTableData.filter(data => !searchBoard || data.name.toLowerCase().includes(searchBoard.toLowerCase()) || data.className.toLowerCase().includes(searchBoard.toLowerCase()))"
        },
        classIdTest() {
            return this.$route.params.classId;
        },
        className() {
            return this.$route.params.className;
        }
    },
    // ----------------------computed 부분 ------------------------//

    // ----------------------method 부분 ------------------------//
    methods:{
        ...mapActions('NNclass', [
            'getClassLists',
            'getMyClassLists',
            'deleteClassUser',
        ]),
        showAllBoards(){
            this.showAllBoard = true
            const vm = this;
            this.showAllBoard;
            vm.boardShowNumber = 5;
        },
        getFormatDate(date){
            var year = date.getFullYear();              //yyyy
            var month = (1 + date.getMonth());          //M
            month = month >= 10 ? month : '0' + month;  //month 두자리로 저장
            var day = date.getDate();                   //d
            day = day >= 10 ? day : '0' + day;          //day 두자리로 저장
            return  year + '년 ' + month + '월 ' + day +'일';       //'-' 추가하여 yyyy-mm-dd 형태 생성 가능
        },
        setPage (val) {
            this.page = val;
        },
        moveTo(row) {
            const vm = this;
            vm.$router.push(`/v4/test2/${row.classId}/test2NNClassQuestionAnswerDetail/${row.boardId}`);
        },
        searchBoards(){
            this.searchBoard = this.tempsearch;
            this.searchType = this.tempSearchType;
            this.tempsearch =''
        }
    },
    // ----------------------method 부분 ------------------------//

    // ----------------------mounted 부분 ------------------------//
    async mounted() {
        const vm = this;
        vm.lectureNum = (await classService.getMyClassList()).data.studyingClasses.length;
        const tempBoards = (await classService.getMyBoards());
        vm.boards = tempBoards.data.boards.map(board => ({
        className: board.class.name,
        name: board.name,
        userName: board.user.name,
        content: board.content,
        date: this.getFormatDate(new Date(board.created_at)),
        dateSort: new Date(board.created_at),
        numViews: board.num_views,
        classId: board.class_id,
        boardId: board.board_id,
        })).sort((a, b) => {
            return b.dateSort - a.dateSort;
        });
        if(this.classIdTest != 0)
        {
            let result =  vm.boards.filter(data => data.classId == (vm.classIdTest) );
            vm.boards = result
        }
        

        
        // console.log(this.boards[0].classId)
        // console.log(this.boards.classId)
        // console.log(this.currentPreviewClass(this.boards.classId))
    // ----------------------mounted 부분 ------------------------//
    }
}
</script>

<style>
    .pagination {
        text-align: right;
    }
    .href{
        text-decoration: none;
        color: black;
        font-size: 14px;
    }
</style>